/**
 * ModServ IRC Services
 * Version 2009
 * Copyright (C) 2007, 2008 Christian Jurk <commx@commx.ws>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __MS_DL_H
#define __MS_DL_H

#include <QString>
#include <QFileInfo>
#include <QDateTime>
#include <QList>
#include <QPluginLoader>

class MModInterface {
  private:
    int m_data;
};

class MModule {
  private:
    QString m_name;
    QString m_version;
    QString m_built;
    QFileInfo m_filePath;
    QDateTime m_loadTime;
    MModInterface *m_interface;
    QPluginLoader *m_pluginLoader;
    bool m_sysMod;

  public:
    MModule(const QString &strFilePath);
    ~MModule();
    void setName(const QString &strName);
    void setVersion(const QString &strVer);
    void setBuilt(const QString &strBuilt);
    void setSysMod(const bool &is_sysmod);
    const QString &name(void);
    const QString &version(void);
    const QString &built(void);
    const bool &isSysMod(void);
    const QFileInfo &filePath(void);
    const QDateTime &loadTime(void);
};

extern QList<MModule *> modList;
extern QString globalDlError;

Q_DECLARE_INTERFACE(MModInterface, "modserv.modinterface/1.0");

#endif /* __MS_DL_H */
