/**
 * ModServ IRC Services
 * Version 2009
 * Copyright (C) 2007, 2008 Christian Jurk <commx@commx.ws>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __MS_LOG_H
#define __MS_LOG_H

#include <iostream>
#include <QString>
#include <QFile>

#define L_NOTICE    0x10
#define L_WARN      0x20
#define L_ERR       0x40
#define L_FATAL     0x80

#define MSTR_LOGFILE  "modserv.log"

class MLog {
  private:
    QFile m_file;
    bool m_opened;
    
  public:
    MLog(const QString &strFile);
    ~MLog();
    void close(void);
    void print(quint32 flags, const QString &strIn);
};

#endif /* __MS_LOG_H */
