/**
 * ModServ IRC Services
 * Version 2009
 * Copyright (C) 2007, 2008 Christian Jurk <commx@commx.ws>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <MS_Protolib.h>
#include <MS_Channels.h>
#include <MS_Servers.h>

void killnumeric(const QString &strNum, const QString &strReason) {
  MTcpSocket *sock = globalMain->socket;
  QString str;
  
  if (virtualServer) {
    str = QString("%1 D %2 :%3 (%4)").arg(virtualServer->numeric64())
             .arg(strNum)
             .arg(virtualServer->name())
             .arg(strReason);
    sock->send(str);
  }
  
  MUser *user;
  if ((user = MUser::find(MP10Parser::base64toint(strNum))))
    deluser(user);
}

void killuser(MUser *user, const QString &strReason) {
  MTcpSocket *sock = globalMain->socket;
  QString str;

  if (virtualServer) {
    str = QString("%1 D %2 :%3 (%4)").arg(virtualServer->numeric64())
             .arg(MP10Parser::inttobase64(user->numeric(), 5))
             .arg(virtualServer->name())
             .arg(strReason);
    sock->send(str);
  }
  
  deluser(user);
}

void deluser(MUser *user) {
  deleteUserFromAllChannels(user);
  userList.remove(user->numeric());
  nickList.remove(user->nick().toLower());
  delete user;
}

void deleteUserFromAllChannels(MUser *user) {
  QList<MChannel *> chanlist = user->channelList();
  
  foreach(MChannel *chan, chanlist) {
    chan->removeMember(user);
  }
}
